DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Attributes | Static Private Attributes | List of all members
IODCommonInstanceReferenceModule Class Reference

Class representing the Common Instance Reference Module: More...

Inheritance diagram for IODCommonInstanceReferenceModule:

## Public Member Functions
| IODCommonInstanceReferenceModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor. More...
| IODCommonInstanceReferenceModule ()
| Constructor.
virtual void | clearData ()
| Clears all data belonging to this module (rules are kept)
virtual | ~IODCommonInstanceReferenceModule ()
| Destructor.
virtual size_t | addReferences (const IODReferences &references, const OFString &studyInstanceUID="", const OFBool clearOldData=OFTrue)
| Add references. More...
virtual OFCondition | read (DcmItem &source, const OFBool clearOldData=OFTrue)
| Read data of this module from given source item. More...
virtual OFCondition | write (DcmItem &destination)
| Write data of this module into given destination item. More...
virtual void | resetRules ()
| Resets rules to their original values.
virtual OFString | getName () const
| Get name of module ("CommonInstanceReferenceModule") More...
OFVector< IODSeriesAndInstanceReferenceMacro::ReferencedSeriesItem * > & | getReferencedSeriesItems ()
| Return reference to list of Referenced Series items. More...
OFVector< StudiesOtherInstancesItem * > & | getStudiesContainingOtherReferences ()
| Return reference to content of Studies Containing Other Referenced Instances Sequence. More...
| StudiesOtherInstancesItem (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules, IODComponent *parent=NULL)
| Constructor. More...
| StudiesOtherInstancesItem (IODComponent *parent=NULL)
| Constructor. More...
virtual | ~StudiesOtherInstancesItem ()
| Destructor.
virtual void | clearData ()
| Clear (removes) all attributes handled by the modules of this component. More...
virtual OFCondition | read (DcmItem &source, const OFBool clearOldData=OFTrue)
| Read data from source item into this module. More...
virtual OFCondition | write (DcmItem &destination)
| Write this module's data into given destination item. More...
virtual void | resetRules ()
| Resets rules to their original values.
virtual OFString | getName () const
| Get name of module ("StudiesContainingOtherReferencedInstancesSequence") More...
virtual OFCondition | getStudyInstanceUID (OFString &value, const signed long pos=0) const
| Get Study Instance UID. More...
virtual OFCondition | setStudyInstanceUID (const OFString &value, const OFBool checkValue=OFTrue)
| Set Study Instance UID. More...
virtual IODSeriesAndInstanceReferenceMacro & | getReferencedSeriesAndInstanceReferences ()
| Get Series And Instance Reference Macro. More...
Public Member Functions inherited from IODModule
| IODModule (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules)
| Constructor. More...
| IODModule ()
| Constructor. More...
| IODModule (const IODModule &rhs)
| Copy constructor, creates shallow copy. More...
IODModule & | operator= (const IODModule &rhs)
| Assignment operator, creates shallow copy. More...
| ~IODModule ()
| Destructor.
Public Member Functions inherited from IODComponent
| IODComponent (OFshared_ptr< DcmItem > item, OFshared_ptr< IODRules > rules, IODComponent *parent=NULL)
| Constructor. More...
| IODComponent (IODComponent *parent=NULL)
| Constructor, creates rules and item from scratch. More...
IODComponent & | operator= (const IODComponent &rhs)
| Assignment operator, copies contained item and rule set from rhs to "this" attribute set. More...
| IODComponent (const IODComponent &rhs)
| Copy constructor, copies reference to contained item and rule set to "this" attribute set. More...
virtual | ~IODComponent ()
| Virtual Destructor.
virtual void | inventMissing ()
| Set missing values by inventing "default values". More...
OFshared_ptr< IODRules > | getRules ()
| Get rules handled by this module. More...
virtual void | makeOptional ()
| Make component optional by turning all attributes requirement types of it to type 3. More...
DcmItem & | getData ()
| Get the data handled by this module. More...
virtual OFCondition | check (const OFBool quiet=OFFalse)
| Check whether this component's data satisfies the underlying rules. More...
virtual int | compare (const IODComponent &rhs) const
| Comparison operator for IOD Components. More...
virtual bool | getValueCheckOnWrite () const
| Get whether attribute value errors will be handled as errors on writing. More...
virtual void | setValueCheckOnWrite (const OFBool checkValue)
| Set whether attribute values should be checked on writing, i.e. More...

## Private Attributes
OFVector< IODSeriesAndInstanceReferenceMacro::ReferencedSeriesItem * > | m_ReferenceSeriesItems
| Vector with all items of the Referenced Series Sequence.
OFVector< StudiesOtherInstancesItem * > | m_StudiesContainingOtherReferencedInstancesSequence
| Items of Studies Containing Other Referenced Instances Sequence.
IODSeriesAndInstanceReferenceMacro | m_ReferencedSeriesAndInstance
| The Series and Instance Reference Macro used in this item.

## Static Private Attributes
static const OFString | m_ComponentName
| Name of this component ("CommonInstanceReferenceModule") More...

## Additional Inherited Members
Static Public Member Functions inherited from IODComponent
static OFCondition | read (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName)
| Static helper function that reads attributes from given item into destination item, as determined by the provided rules and component name. More...
static OFCondition | write (DcmItem &source, IODRules &rules, DcmItem &destination, const OFString &componentName, const OFBool checkValue)
| Static helper function that writes attributes from given item into destination item, as determined by the provided rules and component name. More...
Protected Attributes inherited from IODComponent
OFshared_ptr< DcmItem > | m_Item
| Shared pointer to the data handled by this class. More...
OFshared_ptr< IODRules > | m_Rules
| Rules describing the attributes governed by this class.
IODComponent * | m_Parent
| The parent component (may be NULL) of this class.
OFBool | m_CheckValueOnWrite
| Denotes whether attribute values should be checked on writing, i.e. More...

## Detailed Description

Class representing the Common Instance Reference Module:

Class representing items from the Studies Containing Other Referenced Instances Sequence, as used within the Common Instance Reference Module.

Referenced Series Sequence: (SQ, VM 1-n, Type 1C)

> Series Instance UID: (UI, 1, 1) Referenced Instance Sequence: (SQ, 1-n, 1)

> > SOP Instance Reference Macro

Studies Containing Other Referenced Instances Sequence: (SQ, 1-n, 1C)

> Study Instance UID (UI, 1, 1) Series and Instance Reference Macro

Thus the Common Instance Reference Module lists references to other SOP instances and divides them between those instances that are in the same study, and those that are inside another study.

Studies Containing Other Referenced Instances Sequence: (SQ, 1-n, 1C)

> Study Instance UID (UI, 1, 1) Series and Instance Reference Macro

## Constructor & Destructor Documentation

## ◆ IODCommonInstanceReferenceModule()

IODCommonInstanceReferenceModule::IODCommonInstanceReferenceModule | ( | OFshared_ptr< DcmItem > | item,
|  | OFshared_ptr< IODRules > | rules
| ) |  |

Constructor.

Parameters

  item | The item to be used for data storage. If NULL, the class creates an empty data container.
  rules | The rule set for this class. If NULL, the class creates one from scratch and adds its values.

## Member Function Documentation

## ◆ addReferences()

virtual size_t IODCommonInstanceReferenceModule::addReferences | ( | const IODReferences & | references,
|  | const OFString & | studyInstanceUID = `""`,
|  | const OFBool | clearOldData = `OFTrue`
| ) |  |
| virtual

Add references.

Parameters

  references | The references to be added
  studyInstanceUID | The Study Instance UID of "this" object instance. It's used to decide whether the provided instances (with their own Study Instance UIDs) will go into the Referenced Series Sequence or into the Studies Containing Other Referenced Instances Sequence. If it is left empty, then the method tries to find "this" instances Study Instance UID in the internal item container which may be shared with other modules and thus may already provide the Study Instance UID (e.g. via General Study Module).
  clearOldData | Delete any old references if OFTrue, otherwise keep them

Returns
  EC_Normal if successful, error otherwise

## ◆ clearData()

virtual void IODCommonInstanceReferenceModule::clearData | ( |  | ) |
| virtual

Clear (removes) all attributes handled by the modules of this component.

Rules are not reset.

Reimplemented from IODComponent.

## ◆ getName() [1/2]

virtual OFString IODCommonInstanceReferenceModule::getName | ( |  | ) | const
| virtual

Get name of module ("CommonInstanceReferenceModule")

Returns
  Name of the module ("CommonInstanceReferenceModule")

Implements IODComponent.

## ◆ getName() [2/2]

virtual OFString IODCommonInstanceReferenceModule::getName | ( |  | ) | const
| virtual

Get name of module ("StudiesContainingOtherReferencedInstancesSequence")

Returns
  Name of the module ("StudiesContainingOtherReferencedInstancesSequence")

Implements IODComponent.

## ◆ getReferencedSeriesAndInstanceReferences()

virtual IODSeriesAndInstanceReferenceMacro& IODCommonInstanceReferenceModule::getReferencedSeriesAndInstanceReferences | ( |  | ) |
| virtual

Get Series And Instance Reference Macro.

Returns
  Reference to the Series And Instance Reference Macro structure

## ◆ getReferencedSeriesItems()

OFVector<IODSeriesAndInstanceReferenceMacro::ReferencedSeriesItem*>& IODCommonInstanceReferenceModule::getReferencedSeriesItems | ( |  | ) |

Return reference to list of Referenced Series items.

Returns
  Reference to list of Reference Series Items

## ◆ getStudiesContainingOtherReferences()

OFVector<StudiesOtherInstancesItem*>& IODCommonInstanceReferenceModule::getStudiesContainingOtherReferences | ( |  | ) |

Return reference to content of Studies Containing Other Referenced Instances Sequence.

Returns
  Reference to content of Studies Containing Other Referenced Instances Sequence

## ◆ getStudyInstanceUID()

virtual OFCondition IODCommonInstanceReferenceModule::getStudyInstanceUID | ( | OFString & | value,
|  | const signed long | pos = `0`
| ) |  | const
| virtual

Get Study Instance UID.

Parameters

  value | Reference to variable in which the value should be stored
  pos | Index of the value to get (0..vm-1), -1 for all components

Returns
  EC_Normal if successful, an error code otherwise

## ◆ read() [1/2]

virtual OFCondition IODCommonInstanceReferenceModule::read | ( | DcmItem & | source,
|  | const OFBool | clearOldData = `OFTrue`
| ) |  |
| virtual

Read data of this module from given source item.

Parameters

  source | The item to read from
  clearOldData | If OFTrue, old data is cleared before reading, otherwise it is overwritten/amended.

Returns
  EC_Normal if successful, error otherwise

Reimplemented from IODComponent.

## ◆ read() [2/2]

virtual OFCondition IODCommonInstanceReferenceModule::read | ( | DcmItem & | source,
|  | const OFBool | clearOldData = `OFTrue`
| ) |  |
| virtual

Read data from source item into this module.

Parameters

  source | The item to read from
  clearOldData | If OFTrue, old data is cleared first, otherwise it is overwritten/amended

Returns
  EC_Normal if successful, error otherwise

Reimplemented from IODComponent.

## ◆ setStudyInstanceUID()

virtual OFCondition IODCommonInstanceReferenceModule::setStudyInstanceUID | ( | const OFString & | value,
|  | const OFBool | checkValue = `OFTrue`
| ) |  |
| virtual

Set Study Instance UID.

Parameters

  value | Value to be set (single value only) or "" for no value
  checkValue | Check 'value' for conformance with VR (PN) and VM (1) if enabled

Returns
  EC_Normal if successful, an error code otherwise

## ◆ StudiesOtherInstancesItem() [1/2]

IODCommonInstanceReferenceModule::StudiesOtherInstancesItem | ( | IODComponent * | parent = `NULL` | ) |

Constructor.

Parameters

  parent | The parent component of this module, might be NULL

## ◆ StudiesOtherInstancesItem() [2/2]

IODCommonInstanceReferenceModule::StudiesOtherInstancesItem | ( | OFshared_ptr< DcmItem > | item,
|  | OFshared_ptr< IODRules > | rules,
|  | IODComponent * | parent = `NULL`
| ) |  |

Constructor.

Parameters

  item | The item to be used for data storage. If NULL, the class creates an empty data container.
  rules | The rule set for this class. If NULL, the class creates one from scratch and adds its values.
  parent | The parent of the IOD component (NULL if none or unknown)

## ◆ write() [1/2]

virtual OFCondition IODCommonInstanceReferenceModule::write | ( | DcmItem & | destination | ) |
| virtual

Write data of this module into given destination item.

Parameters

  destination | The item to write to

Returns
  EC_Normal if successful, error otherwise

Reimplemented from IODComponent.

## ◆ write() [2/2]

virtual OFCondition IODCommonInstanceReferenceModule::write | ( | DcmItem & | destination | ) |
| virtual

Write this module's data into given destination item.

Parameters

  destination | Item to write to

Returns
  EC_Normal if successful, error otherwise

Reimplemented from IODComponent.

## Member Data Documentation

## ◆ m_ComponentName

static const OFString IODCommonInstanceReferenceModule::m_ComponentName
| static private

Name of this component ("CommonInstanceReferenceModule")

The name of this component ("StudiesContainingOtherReferencedInstancesSequence")

The documentation for this class was generated from the following file:

- dcmiod/include/dcmtk/dcmiod/modcommoninstanceref.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1